<?php
/**
 * @package Pager
 * @author kenji.uraoka@gmail.c*m
 */
class Pager
{
    /**
     * setting option
     */
    var $_allowed_options = array('limit_per_page', 'limit_pages');

    /**
     * @var int [ for example. 10 , 20 , 30 , 100 ]
     */
    var $_limit_per_page = 10;

    /**
     * @var int [ for example. 10=>1.2.3.4.5.6.7.8.9.10 , 5=>1.2.3.4.5 ]
     */
    var $_limit_pages = 10;

    /**
     * constructor 
     * 
     * @param array $options : allowed $_allowed_options
     * @access public
     */
    function Pager($options = array())
    {
        foreach ($options as $k => $v) {
            if (in_array($k, $this->_allowed_options)) {
                $this->{'_'.$k} = $v;
            }
        }
    }

    /**
     * @param int $total
     * @param int $page
     * @access public
     * @return array
     */
    function Get($total, $page)
    {
        $pages            = ceil($total / $this->_limit_per_page);
        $limit_pages_half = round($this->_limit_pages / 2);
    
        /* current page. */
        if ($page > $pages || $page < 1) {
            $cur = 1;
        } else {
            $cur = $page;
        }
    
        /* minimum & maximum page. */
        if ($pages <= $this->_limit_pages) {
            $min = 1;
            $max = $pages;
        } else {
            if ($cur <= $limit_pages_half) {
                $min = 1;
                $max = $this->_limit_pages;
            } else {
                $min = $cur - $limit_pages_half;
                $max = $min + $this->_limit_pages - 1;

                if ($max > $pages) {
                    $max = $pages;
                    $min = $max - $this->_limit_pages + 1;
                }
            }
        }
    
        $retval        = array();
        $retval['cur'] = $cur;
        $retval['min'] = $min;
        $retval['max'] = $max;
        return $retval;
    }
}
